<template>
    <Layout>
        <q-page class="flex flex-center">
            <div>
                <div v-if="isActive" class="text-center">
                    <q-icon name="phonelink_ring" size="150px" color="teal"></q-icon>
                    <h6 class="q-ma-none text-teal text-bold">CONECTADO</h6>
                    <q-btn class="q-mt-lg" label="DESCONECTAR" color="red" @click="disconnectRequest"></q-btn>
                </div>
                <div v-else>
                    <div v-if="connecting" class="text-center">
                        <q-spinner color="teal" size="50px"></q-spinner>
                        <p class="q-mt-lg">{{ messageConnection }}</p>
                    </div>
                    <div v-else>
                        <q-img width="300px" :src="qrcode"></q-img>
                        <div class="q-mt-lg text-center">
                            <p class="text-teal text-bold">Leia o QRCODE com o seu celular para<br/>conectar sua conta do Whatsapp</p>
                        </div>
                    </div>
                </div>
            </div>
        </q-page>
    </Layout>
</template>

<script setup>
import Layout from '../layouts/MainLayout.vue'
import { api_whatsapp } from "../httpclient/whatsapp";
import {onMounted, ref} from 'vue'
import { io } from 'socket.io-client'

const isActive = ref(false)
const connecting = ref(true)
const qrcode = ref('')
const messageConnection = ref('Conectando ao Whatsapp...')
const socket = io('https://wpp-md-dentalprev.zapdeveloper.com.br');

function disconnectRequest () {
    api_whatsapp.post('/close', { session: 'radar' }).then(response => {
        isActive.value = false;
        connecting.value = true;
    })
}

onMounted(() => {
    socket.on('events', (event) => {
        if (event.state === 'QRCODE') {
            qrcode.value = event.qrCode
            connecting.value = false
        }

        if (event.state === 'SYNC') {
            connecting.value = true
            messageConnection.value = 'Sincronizando sua conexão...'
        }

        if (event.state === 'CONNECTED') {
            connecting.value = false
            isActive.value = true
        }
    })

    //Verificando o status da conexão com o whatsapp
    api_whatsapp.post('/start', { session: 'radar' }).then(response => {
        if (response.data.state === 'CONNECTED') {
            connecting.value = false;
            isActive.value = true;
        }
    })
})
</script>
